package com.kuyuntech.cofarcooking.device.sdk.devmode.core;

import com.kuyuntech.cofarcooking.device.sdk.constant.core.WorkModes;
import com.kuyuntech.cofarcooking.device.sdk.eventbus.core.DevInfo;
import com.kuyuntech.cofarcooking.device.sdk.util.core.CofarSDK;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

@EqualsAndHashCode(callSuper = true)
@Data
@ToString
public class Dicing011 extends BaseDevMode{


    public Dicing011(){

        this.setMode(WorkModes.DICING);

        //时间
        this.setMinTime(60);
        this.setMaxTime(5 * 60);
        this.setDefaultTime(3*60);
        this.setTimeChange(true);

        //电机
        this.setDefaultMotorGear(1);
        this.setMinMotorGear(1);
        this.setMaxMotorGear(2);
        this.setMotorGearChange(true);
        this.setMotorDirectionChange(false);

        //温度
        this.setDefaultTemp(0);
        this.setMinTemp(0);
        this.setMaxTemp(0);
        this.setTempChange(false);

    }


    @Override
    public boolean isTempChange() {


        if("3015".equals(CofarSDK.MODEL)){
            return super.isTempChange();
        }

        DevInfo info = CofarSDK.devInfo();


        int motorGear = info.getMotorGear();

        if(info.getMotorGearBuffer() != -1){
            motorGear = info.getMotorGearBuffer();
        }

        if(motorGear > 4  && motorGear < 12){
            return false;
        }


        if(motorGear == 4){
            return true;
        }

        if(motorGear == 12 ){
            return true;
        }
        if (motorGear<=2){
            return  false;
        }


        return true;
    }

    @Override
    public int getMinTemp() {

        return super.getMinTemp();
    }

    @Override
    public int getMaxTemp() {


        if("3015".equals(CofarSDK.MODEL)){
            return super.getMaxTemp();
        }

        DevInfo info = CofarSDK.devInfo();


        int motorGear = info.getMotorGear();

        if(info.getMotorGearBuffer() != -1){
            motorGear = info.getMotorGearBuffer();
        }

        if(motorGear > 4  && motorGear < 12){
              return 0;
        }


        if(motorGear == 4){
            return 50;
        }

        if(motorGear == 12 ){
            return 50;
        }



        return 130;
    }


    @Override
    public int checkTime(int time) {

//        DevInfo devInfo = CofarSDK.devInfo();
//
//        if(devInfo.getMotorGear() >= 7){
//            if(time > 10 * 60){
//                return  10 * 60;
//            }
//        }

        return super.checkTime(time);
    }

    @Override
    public short checkMotorGear(byte gear) {

//        DevInfo devInfo = CofarSDK.devInfo();
//
//
//        if(gear >= 7){
//            if(devInfo.getTargetTime() > 10 * 6){
//                return  7;
//            }
//        }

        return super.checkMotorGear(gear);
    }
}
